// Auto-generated. Do not edit!

// (in-package mbf_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class GetPathGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.use_start_pose = null;
      this.start_pose = null;
      this.target_pose = null;
      this.tolerance = null;
      this.planner = null;
      this.concurrency_slot = null;
    }
    else {
      if (initObj.hasOwnProperty('use_start_pose')) {
        this.use_start_pose = initObj.use_start_pose
      }
      else {
        this.use_start_pose = false;
      }
      if (initObj.hasOwnProperty('start_pose')) {
        this.start_pose = initObj.start_pose
      }
      else {
        this.start_pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('target_pose')) {
        this.target_pose = initObj.target_pose
      }
      else {
        this.target_pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('tolerance')) {
        this.tolerance = initObj.tolerance
      }
      else {
        this.tolerance = 0.0;
      }
      if (initObj.hasOwnProperty('planner')) {
        this.planner = initObj.planner
      }
      else {
        this.planner = '';
      }
      if (initObj.hasOwnProperty('concurrency_slot')) {
        this.concurrency_slot = initObj.concurrency_slot
      }
      else {
        this.concurrency_slot = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetPathGoal
    // Serialize message field [use_start_pose]
    bufferOffset = _serializer.bool(obj.use_start_pose, buffer, bufferOffset);
    // Serialize message field [start_pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.start_pose, buffer, bufferOffset);
    // Serialize message field [target_pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.target_pose, buffer, bufferOffset);
    // Serialize message field [tolerance]
    bufferOffset = _serializer.float64(obj.tolerance, buffer, bufferOffset);
    // Serialize message field [planner]
    bufferOffset = _serializer.string(obj.planner, buffer, bufferOffset);
    // Serialize message field [concurrency_slot]
    bufferOffset = _serializer.uint8(obj.concurrency_slot, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetPathGoal
    let len;
    let data = new GetPathGoal(null);
    // Deserialize message field [use_start_pose]
    data.use_start_pose = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [start_pose]
    data.start_pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [target_pose]
    data.target_pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [tolerance]
    data.tolerance = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [planner]
    data.planner = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [concurrency_slot]
    data.concurrency_slot = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.start_pose);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.target_pose);
    length += object.planner.length;
    return length + 14;
  }

  static datatype() {
    // Returns string type for a message object
    return 'mbf_msgs/GetPathGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '301d9f5ec2f8f08d1d4e16663a6d2c5a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Get a path from start_pose or current position to the target pose
    
    # Use start_pose or current position as the beginning of the path
    bool use_start_pose
    
    # The start pose for the path; optional, used if use_start_pose is true
    geometry_msgs/PoseStamped start_pose
    
    # The pose to achieve with the path
    geometry_msgs/PoseStamped target_pose
    
    # If the goal is obstructed, how many meters the planner can relax the constraint in x and y before failing
    float64 tolerance
    
    # Planner to use; defaults to the first one specified on "planners" parameter
    string planner
    
    # use different slots for concurrency
    uint8 concurrency_slot
    
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetPathGoal(null);
    if (msg.use_start_pose !== undefined) {
      resolved.use_start_pose = msg.use_start_pose;
    }
    else {
      resolved.use_start_pose = false
    }

    if (msg.start_pose !== undefined) {
      resolved.start_pose = geometry_msgs.msg.PoseStamped.Resolve(msg.start_pose)
    }
    else {
      resolved.start_pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.target_pose !== undefined) {
      resolved.target_pose = geometry_msgs.msg.PoseStamped.Resolve(msg.target_pose)
    }
    else {
      resolved.target_pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.tolerance !== undefined) {
      resolved.tolerance = msg.tolerance;
    }
    else {
      resolved.tolerance = 0.0
    }

    if (msg.planner !== undefined) {
      resolved.planner = msg.planner;
    }
    else {
      resolved.planner = ''
    }

    if (msg.concurrency_slot !== undefined) {
      resolved.concurrency_slot = msg.concurrency_slot;
    }
    else {
      resolved.concurrency_slot = 0
    }

    return resolved;
    }
};

module.exports = GetPathGoal;
